#!/usr/bin/perl

#created by Matthew Hestand, Michiel van Galen, Michel Villerius

#Copyright 2010 Leiden University Medical Center http://www.lgtc.nl/GAPSS


#This file is part of GAPSS.
#
#    GAPSS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    GAPSS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with GAPSS.  If not, see <http://www.gnu.org/licenses/>.

#run as: perl GAPSS_FASTA2FASTQ.pl "FASTA file" "score to use or blank"

#this script converts a FASTA file over to FASTQ 
#quality scores are by default Sanger, but can be adjusted
#notes for user:
#	best sanger score = 
#	best Solexa score = 

#input: FASTA file, and quality score to use
#output: FASTQ file

my $file_to_convert = $ARGV[0];
my $fastq_output_file_name = $file_to_convert.".fq";
my $value_for_quality_score = $ARGV[1];

#set QC value to Sanger best () if no value given
$value_for_quality_score =~ s/\n//;
if ($value_for_quality_score eq ""){
	$value_for_quality_score="a";
}

#check is fasta format
my $line1to4_fasta = `head -n 4 $file_to_convert`;
my @array_line1to4_fasta=split(/\n/,$line1to4_fasta);
if ( (@array_line1to4_fasta[0]=~/^>/) && (@array_line1to4_fasta[1]=~/[TAGCtagcNn]*/) && (@array_line1to4_fasta[2]=~/^>/) && (@array_line1to4_fasta[3]=~/[TAGCtagcNn]*/) ){}else{die "$file_to_convert is not a proper fasta file, terminated analysis\n";}



#open file, open outfile, convert and print output, close infile, close outfile
	open(fasta_file,$file_to_convert)||die "could not open fasta file $file_to_convert\n";
	open(fastq_file,">$fastq_output_file_name")||die "could not open fastq file $fastq_output_file_name to print to\n";
	while (<fasta_file>){
		chop;
		$_ =~ s/\n//;
		if ($_ =~ /^>/){
			$_ =~ s/^>/@/;print fastq_file "$_\n";
		}else{
			print fastq_file "$_\n";
			print fastq_file "+\n";
			my $quality_line = $_;
			$quality_line =~ s/[TAGCtagcNn]/$value_for_quality_score/g;
			print fastq_file "$quality_line\n";	
		}
	}
	close (fasta_file)||die "could not close fasta file $file_to_convert\n";
	close (fastq_file)||die "could not close fastq file $fastq_output_file_name\n";
