#!/usr/bin/perl

#created by Matthew Hestand, Michiel van Galen, Michel Villerius

#Copyright 2010 Leiden University Medical Center http://www.lgtc.nl/GAPSS


#This file is part of GAPSS.
#
#    GAPSS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    GAPSS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with GAPSS.  If not, see <http://www.gnu.org/licenses/>.
#    Modified @12 Nov 2010 by Michel Villerius
#    added  $fastq_line_counter that counts the 4 lines with fastq files.
#    only line 1 can stat with a @ and only line 3 can start with a +
#    this so that older fq files can be processed with this script ass well.
#    the prior version did not take into account that a quality score could start with a @ or +

#use as: perl GAPSS_add_5prime_sequence_v2.pl "FASTQ file" "sequence" "Y or N to overwrite previous file";

#edits a FASTQ file to add sequences at the 5'  end

#define input
my $file_to_convert = $ARGV[0];#should be a fastq file
my $sequence_to_add = $ARGV[1];# a sequence
my $to_rewrite_over_file = $ARGV[2];#Y or N

#define secondary variables from input
$sequence_to_add =~ s/\n//;
my $quality_score_to_add = $sequence_to_add;
$quality_score_to_add =~ s/[CATGcatgNn]/\[/g;
$fastq_output_file_name_sub = $file_to_convert.".sequence_".$sequence_to_add."_added_to_5prime";

	open(fastq_file,$file_to_convert)||die "could not open fasta file $file_to_convert\n";
	open(fastq_file2,">$fastq_output_file_name_sub")||die "could not open fastq file $fastq_output_file_name_sub to print to\n";
	my $is_seq = "yes";
	my $fastq_line_counter = 1 ;
	while (<fastq_file>){
		chop;
		$_ =~ s/\n//;
		if ($_ =~ /^\@/ && $fastq_line_counter eq 1){
			print fastq_file2 "$_\n";
			$is_seq = "yes";
		}elsif ($_ =~ /^\+/ && $fastq_line_counter eq 3){
			print fastq_file2 "$_\n";
			$is_seq = "no";
		}else{
		   if ($is_seq eq "yes"){
			print fastq_file2 "$sequence_to_add$_\n";
		   }elsif ($is_seq eq "no"){
			print fastq_file2 "$quality_score_to_add$_\n";
		   }else{
			die "was error in stript, variable \$is_seq\n";
		   }
		}
		print "$fastq_line_counter \t $_ \n";
		if ($fastq_line_counter == 4) {
			$fastq_line_counter = 1;
		}else {$fastq_line_counter++;}

	}
	close (fastq_file)||die "could not close fasta file $file_to_convert\n";
	close (fastq_file2)||die "could not close fastq file $fastq_output_file_name_sub\n";
	
#write new file over old if requested
if ($to_rewrite_over_file eq "Y"){
	system("mv $fastq_output_file_name_sub $file_to_convert");
}
