#!/usr/bin/perl

#created by Matthew Hestand, Michiel van Galen, Michel Villerius

#Copyright 2010 Leiden University Medical Center http://www.lgtc.nl/GAPSS


#This file is part of GAPSS.
#
#    GAPSS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    GAPSS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with GAPSS.  If not, see <http://www.gnu.org/licenses/>.

#run as: perl GAPSS_remove_bp1.pl "FASTQ file" "Y or N or blank"

#this script runs on a FASTQ format file
#removes the first bp of sequence and quality line
#by default re-writes over old file, otherwise rename "file"._remove_bp1

#input: FASTQ file
#output: FASTQ file (original or new)

	my $file_to_convert_sub = $ARGV[0];
	my $fastq_output_file_name_sub = $file_to_convert_sub."._remove_bp1";
	my $to_rewrite_over_file = $ARGV[1];#Y or N

	#set re-write to default if not specified
	$to_rewrite_over_file =~ s/\n//;
	if ($to_rewrite_over_file eq ""){
		$to_rewrite_over_file = "Y";
	}elsif(($to_rewrite_over_file eq "Y")||($to_rewrite_over_file eq "N")){
	}else{
		die "the request to write over file must be \"Y\" or \"N\" \n";
	}

	#open file, remove bp 1 of quality and sequence, write to new file
	open(fastq_file,$file_to_convert_sub)||die "could not open fasta file $file_to_convert_sub\n";
	open(fastq_file2,">$fastq_output_file_name_sub")||die "could not open fastq file $fastq_output_file_name_sub to print to\n";
	while (<fastq_file>){
		chop;
		$_ =~ s/\n//;
		if ($_ =~ /^\@/){
			print fastq_file2 "$_\n";
		}elsif ($_ =~ /^\+/){
			print fastq_file2 "$_\n";
		}else{
			my $string_to_cut=reverse $_;
			chop($string_to_cut);
			$string_to_cut=reverse($string_to_cut);
			print fastq_file2 "$string_to_cut\n";
		}
	}
	close (fastq_file)||die "could not close fasta file $file_to_convert_sub\n";
	close (fastq_file2)||die "could not close fastq file $fastq_output_file_name_sub\n";
	
	#write new file over old if requested, default is YES
	if ($to_rewrite_over_file eq "Y"){
		system("mv $fastq_output_file_name_sub $file_to_convert_sub");
	}
