#!/usr/bin/perl

#created by Matthew Hestand, Michiel van Galen, Michel Villerius

#Copyright 2010 Leiden University Medical Center http://www.lgtc.nl/GAPSS


#This file is part of GAPSS.
#
#    GAPSS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    GAPSS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with GAPSS.  If not, see <http://www.gnu.org/licenses/>.

#run as: perl GAPSS_scarf2FASTQ.pl "scarf file"

#this script converts a scarf file over to FASTQ 
#retains quality scores as in the scarf file

#input: scarf file
#output: FASTQ file

my $file_to_convert = $ARGV[0];

#check file is scarf
my $line1_scarf = `head -n 1 $file_to_convert`;
if ($line1_scarf =~ /[A-Za-c0-9:]*\:[TAGCtagcNn]*:[A-Za-c0-9]*/){}else{die "$file_to_convert is not a proper scarf file, terminated analysis\n";}

#convert with bash code
my $fastq_output_file_name = $file_to_convert.".fq";
system("rev $file_to_convert|cat|cut -d \'\:\' -f2,1 --output-delimiter\=\" \"|rev|awk \'\{print \"\@header\\n\"\$1\"\\n\+\\n\"\$2\}\' > $fastq_output_file_name");

